<?php

namespace MultiSafepay\Connect\Model;

class ConnectConfigProvider implements \Magento\Checkout\Model\ConfigProviderInterface {

    public function __construct(
    \Magento\Framework\ObjectManagerInterface $objectManager, \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
    ) {
        $this->_objectManager = $objectManager;
        $this->_scopeConfig = $scopeConfig;
    }

    public function GetIssuers() {
        $connect = $this->_objectManager->create('MultiSafepay\Connect\Model\Connect');
        $issuers = $connect->getIssuers();
        return $issuers;
    }

    public function GetYears() {
        $years = [];
        for ($i = date("Y") - 17; $i > date("Y") - 125; $i--) {
            $years[] = [
                'value' => $i,
                'year' => $i
            ];
        }
        return $years;
    }

    public function getConfig() {
        $config = array();

        $config = array_merge_recursive($config, [
            'payment' => [
                'connect' => [
                    'issuers' => $this->GetIssuers(),
                    'years' => $this->GetYears()
                ],
            ],
        ]);

        return $config;
    }

}
